@REM -----------------------------------------------------------------------------
@REM  Project : Cortex-M3 Arty A7 Example design with V2C-DAPLink adaptor board
@REM
@REM  Purpose : Convert out file to hex for both BRAM and QSPI simulation models
@REM            Also convert axf file to elf for bitstream generation
@REM -----------------------------------------------------------------------------

@REM - Create the output files.
@REM - File to load into FPGA RAM
call ielftool --ihex "%~1\Debug\Exe\m3_for_arty_a7.out" "%~1\bram_a7.hex"
@REM - File to load into DAPLink QSPI simulation
call ielftool --bin "%~1\Debug\Exe\m3_for_arty_a7.out" "%~1\qspi_a7.bin"
@REM - File to merge SW into bitstream
copy "%~1\Debug\Exe\m3_for_arty_a7.out" "%~1\bram_a7.elf"

@REM - Copy the files to the relevant directories of the hardware project
copy "%~1\bram_a7.*" "%~1\..\..\..\hardware\m3_for_arty_a7\m3_for_arty_a7"

